package be.iminds.ilabt.jfed.highlevel.jobs;

import be.iminds.ilabt.jfed.lowlevel.api.AbstractGeniAggregateManager;
import be.iminds.ilabt.jfed.lowlevel.authority.SfaAuthority;
import be.iminds.ilabt.jfed.lowlevel.stitching.StitchingDirector;

import javax.annotation.Nullable;
import java.util.List;

/**
 * User: twalcari
 * Date: 1/27/2016
 * Time: 10:59
 */
interface AllocationDirector {

    void reportGiveUp();

    boolean isGaveUp();

    boolean areAnyActionsLeft();

    List<StitchingDirector.StitchAction> getStitchActions();

    StitchingDirector.AllocateVerdict processAllocateResult(StitchingDirector.StitchAction stitchAction,
                                                            AbstractGeniAggregateManager.AggregateManagerReply reply);

    void processListResourcesResult(SfaAuthority auth, @Nullable String advertisementRspec);

    void processDeleteResult(SfaAuthority auth);

    StitchingDirector.AllocateVerdict reportReadyForRetry(SfaAuthority auth);
}
